//Gibson, Dustin
// Graph Drawing Applet
import java.io.*;
import java.lang.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.awt.Color;
//import java.util.Iterator;

class vertex
{
	int x, y;
	int index;
}

class GraphMatrix
{
	//1 - RED, 2 - BLUE, 3 - GREEN, 4 - YELLOW
	int x, y, c;
	int deg, breadth;
	Vector<Integer> adj_list = new Vector<Integer>();
}

class GraphOperations
{
	Vector<GraphMatrix> GM = new Vector<GraphMatrix>();
	Vector<Integer> SV = new Vector<Integer>();
	int n, m;
	String adj_matrix_txt, adj_list_txt, graph_info_txt;
	
	public void init()
	{
		n = 0;
	}
	
	public void clear_all()
	{
		GM.removeAllElements();
		n=0;
	}
	
	public void make_complement()
	{
		for(int i=0; i < n; i++) {
			for(int j=0; j < n; j++) {
				if(i != j) {
					if(GM.get(i).adj_list.get(j) == 1) 
						GM.get(i).adj_list.set(j,0);
					else
						GM.get(i).adj_list.set(j,1);
				}
			}
		}
	}
	
	public int color_vertex(int x)
	{
		int r = 0, b = 0, g = 0, y = 0, cnt = 0;
		Vector<Integer> color_list = new Vector<Integer>();
		for(int i =0; i < n; i++)
			if(GM.get(x).adj_list.get(i) == 1)
				if(GM.get(i).c != 0) {
					color_list.add(GM.get(i).c);
					cnt = cnt + 1;
				}
		for(int j =0; j < cnt; j++) {
			switch(color_list.get(j)) {
				case 1: r = 1; break;
				
				case 2: b = 1; break;
				
				case 3: g = 1; break;
				
				case 4: y = 1; break;
				
				default: r = 1; break;
			}
		}
		
		if(r == 0)
			return 1;
		else if(b == 0)
			return 2;
		else if(g == 0)
			return 3;
		else if(y == 0)
			return 4;
		else
			return 1;
				
	}
	
	public void color_graph()
	{
		for(int z=0; z < n; z++)
			GM.get(z).c = 0;

		for(int i = 0; i < n; i++) {
			GM.get(i).c = color_vertex( i );
		}
	}
	
	public boolean is_prev(Vector<Integer> prev_set, int test)
	{
		for(int i =0; i < prev_set.size(); i++)
			if(prev_set.get(i) == test)
				return true;
		return false;
	}
	
	public boolean is_eulerian()
	{
		if(is_disconnected() == true)
			return false;
		int tally = 0;
		for(int i=0; i < n; i++) {
			for(int j=0; j <n; j++) {
				if(GM.get(i).adj_list.get(j) == 1)
					tally = tally + 1;
			}
			if(tally % 2 != 0)
				return false;
			tally = 0;
		}
		return true;
	}
	
	public boolean is_disconnected()
	{
		Vector<Integer> prev_set = new Vector<Integer>();
		Vector<Integer> set = new Vector<Integer>();
		prev_set.add(0);
		set.add(0);

		for(int i=0; i < set.size(); i++) {
			for(int j=0; j < n; j++) {
				if( GM.get(set.get(i)).adj_list.get(j) == 1 ) {
					if( is_prev( prev_set, j) == false) {
						set.add( j );
						prev_set.add( j );
					}
				}
			}
			if(set.size() == n)
				return false;
		}
		
		return true;
	}
	
	
	public boolean is_copy(Vector<Integer> set)
	{
		for(int i = 0; i < set.size(); i++)
			for( int j =0; j < set.size(); j++)
				if( i != j)
					if(set.get( j ) == set.get( i ) )
						return true;
		return false;
	}
	
	public void find_degrees()
	{
		int tally = 0;
		for(int i =0; i < n; i++) {
			for(int j=0; j < n; j++) {
				if(GM.get(i).adj_list.get(j) == 1) {
					tally = tally + 1;
				}
			}
			GM.get(i).deg = tally;
			tally = 0;
		}
	}
	
	public boolean is_simplicial(int v)
	{
		int cnt = 0;
		Vector<Integer> set = new Vector<Integer>();
		for(int i = 0; i < n; i++) 
			if(GM.get(v).adj_list.get(i) == 1)
				set.add(i);
		for(int j=0; j<set.size(); j++) {
			for(int k=0; k<set.size(); k++) {
				if(GM.get(set.get(j)).adj_list.get(set.get(k)) == 1)
					cnt = cnt + 1;
			}
			if(cnt != set.size() - 1)
				return false;
			cnt = 0;
		}
		return true;
	}
	
	public void find_simplicial_vert()
	{
		//Vector<Integer> simp_vert = new Vector<Integer>();
		for(int i = 0; i < n; i++)
			if(is_simplicial(i) == true)
				SV.add(i);
		//System.out.println("simp");
		//SV.clear();
	}
	
	public boolean is_chordal()
	{
		if(is_disconnected() == true)
			return false;
		Vector<GraphMatrix> tmp_set = new Vector<GraphMatrix>();
		tmp_set = (Vector)GM.clone();
		int tmp_n = n;
		find_simplicial_vert();
		if(SV.isEmpty())
			return false;
		while(!SV.isEmpty()) {
			SV.clear();
			find_simplicial_vert();
			if(n == SV.size()) {
				System.out.println("true");
				SV.clear();
				 n = tmp_n;
				GM = (Vector)tmp_set.clone();
				return true;
			}
			for(int i =0; i < SV.size(); i++)
				delete_vertex(SV.get(0));
			find_simplicial_vert();
		}
			SV.clear();
			 n = tmp_n;
			GM = (Vector)tmp_set.clone();
			return false;
			//}
		//}
	}
	
	public int breadth_search()
	{
		int num_adj = 0, prev_adj = 1, cycle =0;
		for(int a = 0; a < n; a++)
			GM.get(a).breadth = 0;
		int b = 1;
		if(is_disconnected() == true)
			return -1;
		Vector<Integer> set = new Vector<Integer>();
		set.add(0);
		GM.get(0).breadth = 0;
		for(int i=0; i < set.size(); i++) {
			for(int j=0; j < n; j++) {
				if(GM.get(i).adj_list.get(j) == 1 && is_prev(set,j)==false) {
					set.add(j);
					GM.get(j).breadth = b;
					num_adj = num_adj + 1;
				}
			}
			cycle = cycle + 1;
			if(cycle == prev_adj) {
				b = b + 1;
				cycle = 0;
				prev_adj = num_adj;
				num_adj = 0;
			}
		}
		return 1;
	}
	
	public int stability_num()
	{
		if(n == 1)
			return 1;
		Vector<Integer> set = new Vector<Integer>();
		for(int a=0; a < n; a++)
			set.insertElementAt(a,a);
		find_degrees();
		int alpha=0;
		int min= 0;
		int min_index = 0;
		while(set.size() != 0) {
			for(int i=0; i < set.size(); i++) {
				if(GM.get(i).deg <= min) {
					min = GM.get(i).deg;
					min_index = i;
				}
			}
			set.remove(min_index);
			
			if(set.size() == 0) {
				alpha = alpha + 1;
				return alpha;
			}
			
			for(int j=0; j<n;j++)
				if(GM.get(min_index).adj_list.get(j) == 1)
					for(int k =0; k<set.size(); k++)
						if(set.get(k) == j)
							set.remove(k);
			alpha = alpha + 1;
			
			for(int r=0; r < set.size(); r++)
				if(set.get(r) >= 0) {
					min = GM.get(r).deg;
					min_index = r;
				}
		}
		return alpha;
	}
	
	
	public boolean is_tree()
	{
		if( is_disconnected() )
			return false;
		Vector<Integer> prev_set = new Vector<Integer>();
		int prev = -1;
		int cur = 0;
		int proceed = 1;
		for(int i = 0; i < n; i++) {
			cur = i;
			while(proceed == 1) {
				for(int j=0; j < n; j++) {
					if(GM.get(cur).adj_list.get(j) == 1) {
						if(j != prev) {
							if(is_prev(prev_set, j) == false) {
								//System.out.println("step");
								prev_set.add(cur);
								prev = cur;
								cur = j;
							}
							else {
								return false;
							}
						}
					}
				}
				if(prev == prev)
					proceed = 0;
			}
			proceed = 1;
			prev = -1;
			prev_set.clear();
		}
		return true;
	}
	
	public void update_graph_info_text()
	{
		//find_simplicial_vert();
		breadth_search();
		int sn = stability_num();
		int tn = n - sn;
		color_graph();
		graph_info_txt = "Tree? ";
		if(is_tree() == true)
			graph_info_txt = graph_info_txt + " y \n";
		else
			graph_info_txt = graph_info_txt + "n \n";
		graph_info_txt = graph_info_txt + "Disconnected? ";
		if(is_disconnected() == true)
			graph_info_txt = graph_info_txt + "y \n";
		else
			graph_info_txt = graph_info_txt + "n \n";
		graph_info_txt = graph_info_txt + "Eulerian? ";
		if(is_eulerian() == true)
			graph_info_txt = graph_info_txt + "y \n";
		else
			graph_info_txt = graph_info_txt + "n \n";
		graph_info_txt = graph_info_txt + "Chordal? ";
		if(is_chordal() == true)
			graph_info_txt = graph_info_txt + "y \n";
		else
			graph_info_txt = graph_info_txt + "n \n";
		find_degrees();
		graph_info_txt = graph_info_txt +
			"Stability Num: " + Integer.toString(sn) + "\n";
		graph_info_txt = graph_info_txt +
			"Transversal Num: " + Integer.toString(tn) + "\n"; 
	}
	
	public void update_adj_matrix_text()
	{
		adj_matrix_txt = "";
		for(int i =0; i < n; i++) {
			for(int j=0; j < n; j++) {
				if(GM.get(i).adj_list.get(j) == 1)
					adj_matrix_txt = adj_matrix_txt + "1 ";
				else
					adj_matrix_txt = adj_matrix_txt + "0 ";
			}
			adj_matrix_txt =  adj_matrix_txt + " \n";
		}
		//
	}
	
	public void update_adj_list_text()
	{
		adj_list_txt = "";
		for(int i =0; i < n; i++) {
			for(int j=0; j < n; j++) {
				if(GM.get(i).adj_list.get(j) == 1) 
					adj_list_txt = adj_list_txt + Integer.toString(j+1) + " ";
				else
					adj_list_txt = adj_list_txt;
			}
			adj_list_txt =  adj_list_txt + " \n";
		}
	}
	
	public void clear_matrix_text()
	{
		adj_matrix_txt = "";
		adj_list_txt = "";
	}
	
	public void append_edge(int v, int index1, int index2, int addMode) 
	{
		if(addMode == 0)  {
			GM.get(index1).adj_list.add(index2,v);
			GM.get(index2).adj_list.add(index1,v);
		}
		else {
			GM.get(index1).adj_list.set(index2,v);
			GM.get(index2).adj_list.set(index1,v);
		}
		update_adj_matrix_text();
		update_adj_list_text();
		//System.out.println(adj_list_txt);
		//m = m + 1;
	}
	
	public void delete_edge(int index1, int index2)
	{
		GM.get(index1).adj_list.set(index2,0);
		GM.get(index2).adj_list.set(index1,0);
		update_adj_matrix_text();
		update_adj_list_text();
	}
	
	public void append_vert(int x, int y, int vw)
	{
		GraphMatrix tmpGM = new GraphMatrix();
		tmpGM.x = (x+(x-vw))/2;
		tmpGM.y = (y+(y-vw))/2;
		//Insert
		GM.add(tmpGM);
		for(int i = 0; i < GM.size(); i++)
			append_edge(0,n,i,0);
		//Update
		clear_matrix_text();
		for(int j=0; j < GM.size(); j++) {
			append_edge(0,j,n,0);
		}
		clear_matrix_text();
		n = n + 1;
		update_adj_matrix_text();
		update_adj_list_text();
	}
	
	public void delete_vertex(int v)
	{
		int nrows=0, ncols=0;
		Vector<GraphMatrix> newGM = new Vector<GraphMatrix>();
		for(int i=0; i < n; i++) {
			if(i != v)  {
				GraphMatrix tmpnewGM = new GraphMatrix();
				tmpnewGM.x = GM.get(i).x;
				tmpnewGM.y = GM.get(i).y;
				newGM.add(tmpnewGM);
				ncols = 0;
				for(int j=0; j < n; j++) {
					if( j != v) {
						if(GM.get(i).adj_list.get(j) == 1)
							newGM.get(nrows).adj_list.add(1);
						if(GM.get(i).adj_list.get(j) == 0)
							newGM.get(nrows).adj_list.add(0);
						ncols = ncols + 1;
					}
				}
				nrows = nrows + 1;
			}
		}
		GM.clear();
		GM = newGM;
		n = nrows;
		//update_adj_matrix_text();
		//update_adj_list_text();
	}
}

public class main extends Applet implements ActionListener , ItemListener
{
	
	Image Buffer;
	Graphics gB;
	
	CheckboxGroup list_choices;
	Checkbox adj_list_choice;
	Checkbox adj_matrix_choice;
	
	boolean mouse_down;
	int mx=0,my=0;
	int width, height, vw;
	int mode; //1 => |V| 	2 => |E| 
	int edge_mode = 0; // 0 => NA	1=> v1	2=>v2
	int bfs_mode = 0;
	vertex v1 = new vertex();
	vertex v2 = new vertex();
	Button vButton, eButton, cButton, clearButton, 
		deButton, dvButton, bfsButton, dragButton;
	TextArea textLists, graphInfo;
	int drag_target = -1;

	GraphOperations Gops = new GraphOperations();

	public void init() 
	{
		setBackground( Color.gray );
		Buffer = createImage(size().width,size().height);
		gB = Buffer.getGraphics();
		vw = 20;
		mode = 0;
		edge_mode = 0;
		setLayout(null);
		deButton = new Button("Delete |E|");
		dvButton = new Button("Delete |V|");
		vButton = new Button("Draw |V|");
		eButton = new Button("Draw |E|");
		cButton = new Button("Draw ~G");
		clearButton = new Button("Clear G");
		bfsButton = new Button("BFS");
		dragButton = new Button("Drag |V|");
		list_choices =  new CheckboxGroup();
		adj_list_choice = new Checkbox("L(G)",list_choices,false);
		adj_matrix_choice = new Checkbox("A(G)",list_choices,true);
		graphInfo = new TextArea("",5,40);
		textLists = new TextArea("",5,40);
		//width = getSize().width;
		//height = getSize().height;
		//x > 500 for GUI
		dvButton.setBounds(500,30,80,30);
		deButton.setBounds(580,30,80,30);
		bfsButton.setBounds(660,30,80,30);
		dragButton.setBounds(500,60,80,30);
		clearButton.setBounds(0,0,80,30);
		graphInfo.setBounds(500,100,200,150);
		textLists.setBounds(500,300,200,150);
		vButton.setBounds(500,0,80,30);
		eButton.setBounds(580,0,80,30);
		cButton.setBounds(660,0,80,30);
		adj_matrix_choice.setBounds(500,450,140,30);
		adj_list_choice.setBounds(640,450,140,30);
		
		add(dragButton);
		add(bfsButton);
		add(dvButton);
		add(deButton);
		add(graphInfo);
		add(clearButton);
		add(adj_matrix_choice);
		add(adj_list_choice);
		add(textLists);
		add(vButton);
		add(eButton);
		add(cButton);
		
		bfsButton.addActionListener(this);
		dvButton.addActionListener(this);
		deButton.addActionListener(this);
		adj_list_choice.addItemListener(this);
		adj_matrix_choice.addItemListener(this);
		clearButton.addActionListener(this);
		vButton.addActionListener(this);
		eButton.addActionListener(this);
		cButton.addActionListener(this);
		dragButton.addActionListener(this);

	}
	

	public void itemStateChanged(ItemEvent e) {
		if(e.getStateChange() == ItemEvent.SELECTED)
			update_matrix_textbox();
	}
	
	public void update_matrix_textbox()
	{
		textLists.setText("");
		if(adj_matrix_choice.getState()) {
			Gops.update_adj_matrix_text();
			textLists.insert(Gops.adj_matrix_txt,0);
		}
		else if(adj_list_choice.getState()) {
			Gops.update_adj_list_text();
			textLists.insert(Gops.adj_list_txt,0);
		}
		Gops.clear_matrix_text();	
	}
	
	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource() == clearButton) {
			Gops.clear_all();
			update_matrix_textbox();
			repaint();
		}
		if(e.getSource() == vButton) {
			mode = 1;
			edge_mode = -1;
			repaint();
		}
		else if(e.getSource() == eButton) {
			mode = 2;
			edge_mode = 0;
			repaint();
		}
		else if(e.getSource() == dvButton) {
			mode = 3;
			edge_mode = -1;
			repaint();
		}
		else if (e.getSource() == deButton) {
			mode =4;
			edge_mode = 0;
			repaint();
		}
		else if(e.getSource() == cButton) {
			Gops.make_complement();
			graphInfo.setText("");
			Gops.update_graph_info_text();
			graphInfo.insert(Gops.graph_info_txt,0);
			update_matrix_textbox();
			repaint();
		}
		else if(e.getSource() == bfsButton) {
			if(bfs_mode == 1)
				bfs_mode = 0;
			else
				bfs_mode = 1;
			repaint();
		}
		else if(e.getSource() == dragButton) {
			mode = 5;
		}
	}
	
	public boolean mouseDrag(Event evt,int x,int y)
	{
		GraphMatrix tmpGM = new GraphMatrix();
		
		if(mode == 5) {
			if(drag_target == -1) 
				for(int i = 0; i < Gops.GM.size(); i++) 
					if(Gops.GM.get(i).x <= x && Gops.GM.get(i).x + vw > x)
						if(Gops.GM.get(i).y <= y && Gops.GM.get(i).y + vw > y) 
							drag_target = i;
		
			tmpGM.x = x;
			tmpGM.y = y;
			tmpGM.c = Gops.GM.get( drag_target ).c;
			tmpGM.adj_list = Gops.GM.get( drag_target).adj_list;
			Gops.GM.set( drag_target, tmpGM);
		}
		repaint();
		return true;
	}


	public boolean mouseMove(Event evt,int x,int y)
	{
		mx = x;
		my = y;
		repaint();
		return true;
	}
	
	public boolean mouseDown(Event e, int x, int y)
	{
		mouse_down = true;
		if(mode == 1) {
			Gops.append_vert(x,y,vw);
			graphInfo.setText("");
			Gops.update_graph_info_text();
			graphInfo.insert(Gops.graph_info_txt,0);
			textLists.setText("");
			if(adj_matrix_choice.getState())
				textLists.insert(Gops.adj_matrix_txt,0);
			else if(adj_list_choice.getState())
				textLists.insert(Gops.adj_list_txt,0);
			
			repaint();
		}
		
		if(mode == 3) {
			for(int k = 0; k < Gops.GM.size(); k++) 
				if(Gops.GM.get(k).x <= x && Gops.GM.get(k).x + vw > x) 
					if(Gops.GM.get(k).y <= y && Gops.GM.get(k).y + vw > y) {
						Gops.delete_vertex(k);
					}
			graphInfo.setText("");
			Gops.update_graph_info_text();
			graphInfo.insert(Gops.graph_info_txt,0);
			update_matrix_textbox();
			repaint();
		}
		
		if(mode == 2 || mode == 4) {
			for(int i = 0; i < Gops.GM.size(); i++) {
				if(Gops.GM.get(i).x <= x && Gops.GM.get(i).x + vw > x)
					if(Gops.GM.get(i).y <= y && Gops.GM.get(i).y + vw > y) {
						if(edge_mode == 0) {
							v1.x = x;
							v1.y = y;
							v1.index = i;
							edge_mode = 1;
						}
						else if(edge_mode == 1 && v1.index != i) {
							v2.x = x;
							v2.y = y;
							v2.index = i;
							Gops.clear_matrix_text();
							if(mode == 2)
								Gops.append_edge(1,v1.index, v2.index,1);
							else if(mode == 4)
								Gops.delete_edge(v1.index, v2.index);
							graphInfo.setText("");
							Gops.update_graph_info_text();
							graphInfo.insert(Gops.graph_info_txt,0);
							update_matrix_textbox();
							//textLists.inser("");
							edge_mode = 0;
						}
					}
									
			}
			
			
			//x_draw_init = x_draw_end = x;
			//y_draw_init = y_draw_end = y;
			repaint();
		}
		
		if( mode == 5 && drag_target != -1) {
			System.out.println(drag_target);
			drag_target = -1;
			//mode = 0;
		}
		
		return true;
	}
	
	public void update(Graphics g)
	{
		paint(g);
	}

	
	public void paint( Graphics g ) 
	{
		gB.clearRect(0,0,size().width,size().height); 
		//textLists.setText("")
		gB.setColor(Color.black);
		
		if(mode == 1) {
			gB.drawString("Click to place vertex",90,50);
		}
		else if(mode == 2) {
			if(edge_mode == 1)
				gB.drawString("Click terminal vertex to finish edge",90,50);
			else
				gB.drawString("Click starting vertex to create edge",90,50);
		}
		if(mode == 3) {
			gB.drawString("Click on a vertex to delete",90,50);
		}
		else if(mode == 4) {
			if(edge_mode == 1)
				gB.drawString("Click terminal vertex to delete edge",90,50);
			else
				gB.drawString("Click starting vertex to delete edge",90,50);
		}
		else if(mode == 5) 
			gB.drawString("Drag a selected vertex to a new location",90,50);
		
		gB.setColor(Color.black);
		
 		for(int j = 0; j < Gops.GM.size(); j++) { 
  			for(int k=0; k < Gops.GM.size(); k++) {
  				if(Gops.GM.get(j).adj_list.get(k) == 1) {
					int tmpX = (Gops.GM.get(j).x + (Gops.GM.get(j).x + vw))/2;
					int tmpY = (Gops.GM.get(j).y + (Gops.GM.get(j).y + vw))/2;
					int tmpX2 = (Gops.GM.get(k).x + (Gops.GM.get(k).x + vw))/2;
					int tmpY2 = (Gops.GM.get(k).y + (Gops.GM.get(k).y + vw))/2;
  					gB.drawLine(tmpX,tmpY,tmpX2, tmpY2);
  				}
  			}
  		}
		
		for(int i = 0; i < Gops.GM.size(); i++) {
			if(Gops.GM.get(i).c == 1)
				gB.setColor(Color.red);
			else if(Gops.GM.get(i).c == 2)
				gB.setColor(Color.blue);
			else if(Gops.GM.get(i).c == 3)
				gB.setColor(Color.green);
			else if(Gops.GM.get(i).c == 4)
				gB.setColor(Color.yellow);
			else
				gB.setColor(Color.black);
			gB.fillOval(Gops.GM.get(i).x, Gops.GM.get(i).y,  vw, vw);
			gB.drawString(Integer.toString(i),Gops.GM.get(i).x, Gops.GM.get(i).y);
			if(bfs_mode == 1) {
				gB.setColor(Color.white);
				gB.drawString(Integer.toString(Gops.GM.get(i).breadth),((Gops.GM.get(i).x + (Gops.GM.get(i).x + vw))/2) - 5,
				((Gops.GM.get(i).y + (Gops.GM.get(i).y + vw))/2) + 5 );
			}
			gB.setColor(Color.black);

			Gops.find_simplicial_vert();
			for(int k=0; k < Gops.SV.size(); k++)
				gB.drawString("S",Gops.GM.get(Gops.SV.get(k)).x+vw,Gops.GM.get(Gops.SV.get(k)).y);
			Gops.SV.clear();
		}
		
		gB.setColor(Color.pink);
		if(mode == 2)
			if(edge_mode == 1)
				gB.drawLine(v1.x,v1.y,mx,my);
			
		
		gB.setColor(Color.black);
		g.drawImage (Buffer,0,0, this);
	}
		//gB.drawLine( x_draw_init, y_draw_init, x_draw_end, y_draw_end);
}
